/* XBBS Library Utility (1.09) for Zoo-archived Text File Libraries */
/* Copyright 1988/89/90/91/92 by M. Kimes -- All Rights Reserved */
/* Modified source code or executable may not be distributed except */
/* for foreign language ports */

#include "library.h"


/*-Function declarations------------------------------------------------*/


void   pascal free_docs(void);
void   pascal hitreturn(void);
void   pascal cls(void);
char   pascal inkey (void);
char   pascal carrchk (void);
char   pascal fossil (char function, char arg);
char   pascal printm (char *text);
void   cdecl  deinitialize (void);
char * pascal genin (char length,char password,char caps,char hot,char type);
char * pascal fidodate (void);
long   pascal getxbbstime(void);
char   pascal specialkey(char);
int    cdecl  break_handler(void);
char   pascal readtext(char *);
char   pascal printg(char *);
char   pascal skip_blanks(int handle);
void   pascal chat(void);
void   pascal printinfo(void);
word   pascal load_sections(void);
void   pascal list_sections(void);
char * pascal lstrip(char *);
void   pascal readfile(word,word);
word   pascal security(void);
void   pascal full_list(char *keyword);
void   pascal quick_list(void);
void   pascal printmenu(void);
char * pascal rstrip(char *);
int    cdecl  printfm(char *,...);
int    cdecl aprintf (char *string,...);
char * pascal stristr(char *,char *);
void   pascal status(void);
void   pascal curr_cursor (int *x, int *y);
char * pascal stripcr (char *a);
char * pascal fgetsx (char *str,int num,int handle);
extern int    pascal list_zoo (word secnum,char printit,char justheader,char *searchfor);
extern void   pascal maintenance(void);
extern void   pascal print_maint_menu(void);
extern int    pascal name_match (char *mask,char *name);
extern int    pascal common (int func);
extern int    pascal trim_section (word secnum,word howmany);

/*- Global variables ----------------------------------------*/


#define MAXFILES    4096
#define MAXSECTIONS 1024
#define MAXPTRS     1024

char   libmenu=0;
char   maintmenu=0;
char  *section[MAXSECTIONS];
char  *document[MAXFILES];
word   numsecs=0;
word   numfiles=0;
char   graphics=0;
char   pauser=0;
word   lines=0;
long   timelimit=1800;
word   baud=0;
char   numlines=24;
int    seclvl=5;
long   startt=0;
char   commport=0;
union  REGS rg;
char   home_dir[128]="";
char   lib_dir[128]="";
char   logfile[133]="*.*";
char   jumped=0;
char   username[36]="I Dunno Who It Is";
char   width=80;
char   fast=0;
char   chatting=0;
char   chatted=0;
char   secfile[99]="";
char   quick=0;
char   full=0;
char   grapharea=0;
char   sysmode=0;
char   menus=0;
char   reader[99]="";
char   maint=0;
char   node=1;
word   cursec=0;
char   tmpin[13]="";
char   tmpout[13]="";
char   nowatchdog=0;
char   lastextracted[13]="";

void   pascal main2 (int argc,char *argv[]);

/*- Let the carnage begin ---------------------------------*/




void pascal main2 (int argc,char *argv[]) {

    register word x,y;
    word temp;
    char s[132];
    struct ffblk f;
    FILE *fp;
    int handle;
  char command,settask = 0;
    char *p;

  set_screensize(1);
  ansi_out("\x1b[2J");
  ctrlbrk(break_handler);
  timelimit+=time(NULL);
  for (x=0;x<MAXSECTIONS;x++) section[x]=NULL;
  for (x=0;x<MAXFILES;x++) document[x]=NULL;

  if (argc == 2 && !strcmp(strupr(argv[1]),"H")) {
GiveHelp:
    ansi_out("\x1b[0;1;37m\r\nLibrary v1.09-- an XBBS Utility.\x1b[0m");
    printinfo();
    ansi_out("\r\nUsage:  LIBRARY.EXE args...\r\n"
      "L<screen lines>\r\n"
      "W<screen width>\r\n"
      "T<time in minutes>\r\n"
      "B<baudrate (0-38400...?)>\r\n"
      "G<graphics (0 or 1)>\r\n"
      "C<commport (0=COM1)>\r\n"
      "S<security level>\r\n"
      "V<videomode (0=direct video, 1=BIOS)>\r\n"
      "H<home directory> (Defaults to start directory)\r\n"
      "D<library directory> (Defaults to start directory)\r\n"
      "F<security file> (Defaults to none)\r\n"
      "! (Sysop-mode...read any file on the system)\r\n"
      "R (Reader mode...read any file in current directory)\r\n"
      "A<filename> (Display file through ANSI.SYS)\r\n"
      "N<filename> (Display file without stopping at end)\r\n"
      "P<filename> (Display file 'paged' style)\r\n"
      "E<filename> (Use external reader locally)\r\n"
      "Q (Quit)\r\n"
      "X<filename> (Logfile)\r\n"
      "$<#> (Maintenance option will be available at level <#>)\r\n"
      "#<#> (Node=#, default 1)\r\n"
      "@ (No FOSSIL carrier watchdog during maint spawns (not applicable locally))\r\n"
      "M (no multitasker timeslicing)\r\n"
      "Z<#> Tabsize\r\n"
      "U<User_Name>\r\n"
      "I<SectionName>*<#> (Trim <SectionName> to <#> documents--current dir!)\r\n");
    exit(0);
  }

  atexit(deinitialize);

  for (x = 1;x < argc;x++) {
   if(*argv[x] == '-' || *argv[x] == '/')
     memmove(argv[x],&argv[x][1],strlen(argv[x]));
   switch (toupper(*argv[x])) {
        case 'L':   numlines=(char)atoi(&argv[x][1]);
                    break;
        case 'W':   width=(char)atoi(&argv[x][1]);
                    break;
        case 'B':   baud=(word)atoi(&argv[x][1]);
                    break;
        case 'G':   if (atoi(&argv[x][1])) graphics=1;
                    break;
        case 'C':   commport=(char)atoi(&argv[x][1]);
                    fossil(INIT,0);
                    break;
        case 'S':   seclvl=atoi(&argv[x][1]);
                    break;
        case 'T':   timelimit=(atol(&argv[x][1]) * 60L)+time(NULL);
                    break;
    case 'V':   usebios=atoi(&argv[x][1]);
                break;
    case 'M': settask = 1;
          break;
        case 'H':   strcpy(home_dir,strupr(&argv[x][1]));
                    break;
        case 'D':   strcpy(lib_dir,strupr(&argv[x][1]));
                    break;
        case 'F':   strcpy(secfile,&argv[x][1]);
                    break;
        case '!':   sysmode=1;
                    break;
        case 'R':   sysmode=2;
                    break;
        case 'N':
        case 'A':   fossil(INIT,0);
                    grapharea=1;
                    readtext(&argv[x][1]);
                    grapharea=0;
                    if (*argv[x]=='A') hitreturn();
                    break;
        case 'P':   fossil(INIT,0);
                    readtext(&argv[x][1]);
                    break;
        case 'Q':   exit(0);
        case 'E':   strcpy(reader,&argv[x][1]);
                    break;
        case 'X':   strcpy(logfile,&argv[x][1]);
                    break;
        case '$':   maint=(char)atoi(&argv[x][1]);
                    break;
        case '#':   node=(char)atoi(&argv[x][1]);
                    break;
        case '@':   nowatchdog=1;
                    break;
    case 'Z': tabspaces = atoi(&argv[x][1]);
              break;
    case '?': goto GiveHelp;
    case 'U': strncpy(username,&argv[x][1],32);
              username[31] = 0;
              while((p = strchr(username,'_')) != NULL) *p = ' ';
              break;
    case 'I':   fossil(DEINIT,0);
                    baud=0;
                    cursec=temp=0;
                    p=strchr(argv[x],'*');
                    if(!p) {
ErrorInI:
            aprintf("\r\n\04Error in I command `%s' %u %u\r\n",argv[x],temp,cursec);
                        exit(6);
                    }
                    *p=0;
                    p++;
                    temp=(word)atol(p);
                    if(!temp) goto ErrorInI;
                    numsecs=load_sections();
                    cursec=65535;
                    for(y=0;y<numsecs;y++) {
                        if(!stricmp(section[y],&argv[x][1])) {
                            cursec=y;
                            break;
                        }
                    }
                    if(cursec==65535) goto ErrorInI;
                    list_zoo(cursec,0,0,NULL);
                    if(numfiles<=temp) {
            aprintf("\r\n\04Section `%s' is within %u documents.\r\n",&argv[x][1],temp);
                        exit(0);
                    }
                    exit(trim_section(cursec,temp));
    default:  aprintf("\r\x1b[K\04Unknown argument `%s'\r\n",argv[x]);
              my_sleep(1);
    }
  }
  fossil(INIT,0);

  if(!settask) set_mtask();

  cls();
  status();
  printg("\x1b[0;1;37m");
  printm("\r\nLIBRARY v1.09");
  printinfo();

  if ((handle = _open("USERINFO.XBS",O_RDONLY | O_BINARY | O_DENYNONE)) != -1) {
      fgetsx(username,36,handle);
      _close(handle);
      if (username[strlen(username)-1]=='\n') username[strlen(username)-1]=0;
  }
  else {
      if ((handle=_open("ONLINE.XBS",O_RDONLY | O_BINARY | O_DENYNONE))!=-1) {
        fgetsx(username,36,handle);
        _close(handle);
      }
  }
  if (!*username) strcpy(username,"I Dunno Who It Is");
  username[31]=0;
  status();

  if (!*home_dir) {
    getcurdir(0,s);
    sprintf(home_dir,"%c:\\%s",getdisk()+'A',s);
  }
  else if (home_dir[strlen(home_dir)-1]=='\\') home_dir[strlen(home_dir)-1]=0;

  if (*lib_dir) {
     if (lib_dir[1]==':') {
        setdisk(*lib_dir-'A');
     }
     if (lib_dir[strlen(lib_dir)-1]=='\\') lib_dir[strlen(lib_dir)-1]=0;
     chdir (lib_dir);
  }

  if (!strcmp(logfile,"*.*")) sprintf(logfile,"%s\\XBBS.LOG",home_dir);

  if(searchpath("LIBRARY.MNU")) libmenu=1;
  if(searchpath("LIBMAINT.MNU")) maintmenu=1;

  sprintf(tmpin,"LIBIN$$$.%03hu",node);
  sprintf(tmpout,"LIBOUT$$.%03hu",node);
  unlink(tmpin);
  unlink(tmpout);

  if (sysmode==1) {
  ansi_out("\r\x1b[K\04SysOp Mode");
    while (1) {
        printg("\x1b[0;1;36m");
    printm("\r\nFilename to read: ");
        strcpy(s,genin(99,0,1,0,FLEP));
    printm("\r\n");
        if (!*s) {
            printg("\x1b[0;1;35m");
            printm(" Quit? (Y/n) ");
            if (*genin(1,0,1,1,YESNO)!='N') exit(0);
      printm("\r\n Toggle ANSI? (y/N) ");
      if (*genin(1,0,1,1,YESNO)!='N') graphics = 1 - graphics;
      if(!graphics) printm("\x1b[0m\r    \r");
            continue;
        }
        printm("[P]aged or [T]yped? [P] ");
        if (*genin(1,0,1,1,ALPHA)=='T') grapharea=1;
        else grapharea=0;
        readtext(s);
    }
  }
  if (sysmode==2) {
  ansi_out("\r\x1b[K\04Reader Mode");
    while (1) {
        printg("\x1b[0;1;36m");
    printm("\r\nFilename to read ([Enter] exits): ");
        strcpy(s,genin(12,0,1,0,FLE));
    printm("\r\n");
        if (!*s) {
            printg("\x1b[0;1;35m");
            printm(" Quit? (Y/n) ");
            if (*genin(1,0,1,1,YESNO)!='N') exit(0);
      printm("\r\n Toggle ANSI? (y/N) ");
            if (*genin(1,0,1,1,YESNO)!='N') graphics=1-graphics;
            continue;
        }
        printm("[P]aged or [T]yped? [P] ");
        if (*genin(1,0,1,1,ALPHA)=='T') grapharea=1;
        else grapharea=0;
        readtext(s);
    }
  }
  numsecs=load_sections();
  if (*secfile) numsecs=security();
  printg("\x1b[0m");
  if (numsecs==0) {
  printm("\r\nSorry, the Library is empty.\r\n");
    my_sleep(1);
    exit(0);
  }
  printfm("\r\n%u section%s available.\r\n",numsecs,&"s"[numsecs == 1]);

  list_zoo(cursec,0,0,NULL);

MainLoop:

  while (1) {

    pauser=0;
    fossil(PURGEIN,0);
    printg("\x1b[0;1;34m");
  printfm("\r\nYou are in Library Section #%u (%s)\r\n",cursec+1,section[cursec]);
  printfm("%u document%s available.\r\n",numfiles,&"s"[numfiles == 1]);
  if (*section[cursec]=='_') {
    if(!graphics) {
      while(!fossil(TRANSMIT,'\07')) carrchk();
      printm("WARNING!  ");
    }
    printm("ANSI Graphics are required in this section.\r\n");
  }
    printg("\x1b[0;1;36m");
    if (!menus) printmenu();
    else printm("\r\n[A,B,F,H,J,L,N,P,Q,R,S,<>,?]");
    printg("\x1b[0;1;34m");
  printfm("\r\n  %ld mins: ",(timelimit-getxbbstime())/60L);
    printg("\x1b[36m");
    command=*genin(1,0,1,1,ALLL);
  printm("\r\n");

    switch (command) {
        case '?':   if(menus) {
                        printmenu();
                        break;
                    }
        case 'H':   if(searchpath("LIBRARY.HLP")) {
                        readtext(searchpath("LIBRARY.HLP"));
                    }
          else printm("\r\nSorry, no help available.\r\n");
                    break;
        case 'M':   if(!maint) goto Default;
                    maintenance();
                    break;
        case 'Q':   exit(0);
        default:
Default:
                    if(!common(command)) {
                        printm("\07");
                        if (menus) {
                            printg("\x1b[0;1;36m");
                            printmenu();
                        }
                        break;
                    }
    }
  }
}



void pascal printmenu (void) {

    if(libmenu) {
        readtext("LIBRARY.MNU");
    }
    else {
        pauser=0;
    printm("\r\n[A]NSI Graphics Toggle                   [B]rowse for Keyword"
         "\r\n[F]ull List/Menu Toggles                 [H]elp w/Library  [?]Help/Full Menu"
         "\r\n[J]ump to another Section                [L]ist Documents in this Section"
         "\r\n[N]ext Section [>]                       [P]revious Section [<]"
         "\r\n[Q]uit the Library                       [R]ead a Document"
         "\r\n[S]ections in Library");
        if(maint)printm("                    [M]aintenance");
    }
}



void pascal readfile (word x,word z) {

    char s[133];
    char *p;
    struct ffblk f;
    register word y;
    int handle;

  printm("\r\nHold on, extracting file...");
    sprintf(s,"ZOO eO %s %s",section[z],document[x]);
    system(s);
  set_screensize(1);
  validate_cursor();
  status();
    strcpy(lastextracted,document[x]);
    for (y=0;y<27;y++) printm(BACKSPACE);
    if (findfirst(document[x],&f,0)) {
        *lastextracted=0;
    printm("\r\nAttempt failed.\r\n");
        return;
    }
    readtext(document[x]);
    remove(document[x]);

    if (*logfile) {
        if(!access(logfile,2)) {
            handle = _open(logfile,O_RDWR | O_DENYNONE | O_BINARY);
            if(handle == -1) {
                handle = creat(logfile,S_IWRITE);
            }
            if(handle == -1) return;
            p = fidodate();
            p[16] = 0;
            sprintf(s,"%s  LIBRARY: Read %s\r\n",p,document[x]);
            write(handle,s,strlen(s));
            _close(handle);
        }
    }
}




word pascal load_sections (void) {

    struct ffblk f;
    word x=0;
    char toggler=0;
    char togchar[]="|/-\\";

    if (!findfirst("*.ZOO",&f,0)) {
        do {
            if(x && !(x%25)) {
                pauser=0;
                toggler++;
        if(toggler > 3) toggler=0;
        aprintf("%c\b",togchar[toggler]);
                if(baud) {
                    while(!fossil(TRANSMIT,togchar[toggler])) carrchk();
                    while(!fossil(TRANSMIT,'\b')) carrchk();
                }
            }

            section[x]=(char *)malloc((word)sizeof(char [13]));
            if(!section[x]) {
        printm("\r\nNo memory for sections\r\n");
                exit(4);
            }
            strcpy(section[x],strtok(f.ff_name,"."));
            x++;
        } while (!findnext(&f) && x<MAXSECTIONS);
        if(x>=25) printm(" \b");
    }
    return x;
}



void pascal list_sections (void) {

    register word x;
    char s[81];

    printg("\x1b[0;1;37m");
    pauser=1;
  printm("\r\n  Available Sections:\r\n");
    pauser=2;
    for (x=0;x<numsecs;x++) {
        if (graphics) printfm("%s%-5u %s%-8s     ","\x1b[0;1;34m",x+1,"\x1b[36m",section[x]);
        else printfm("%-5u %-8s     ",x+1,section[x]);
        if (!((x+1)%4)) {
            pauser=1;
      if (printm("\r\n")) break;
            pauser=2;
        }
        if (inkey()==' ') break;
    }
    if ((x+1)%4) {
        pauser=2;
    printm("\r\n");
    }
    pauser=0;
    if (numlines) if (lines>numlines-12) hitreturn();
}



void pascal full_list (char *keyword) {

    struct ffblk f;
    char ff1[13];
    char s[127];
    char *t;
    char p=0;
    FILE *fp;
    int handle;
    register word x;
    char isansi[23]="";
    struct fdate {
      bit day:   5;
      bit month: 4;
      bit year:  7;
    };
    union df {
      struct fdate fd;
      int x;
    } fdf;


        if(!keyword) {
            printg("\x1b[0;1;37m");
            pauser=1;
            printm("\r\n  Available Sections:\r\n");
        }
        for (x=0;x<numsecs;x++) {
            if (inkey()==' ') break;
            sprintf(ff1,"%s.ZOO",section[x]);
            if (!findfirst(ff1,&f,0)) {
                fdf.x=f.ff_fdate;
                if (*ff1=='_') strcpy(isansi," \x1b[0m-- \x1b[0;2;36mANSI");
                else *isansi=0;
        if (graphics) sprintf(s,"%s%-5u %s%-8s \x1b[0m-- \x1b[0;1;34m%7lu bytes \x1b[0m-- \x1b[0;1;34m%02u/%02u/%u%s\r\n","\x1b[0;1;34m",x+1,"\x1b[36m",section[x],f.ff_fsize,fdf.fd.month,fdf.fd.day,fdf.fd.year+80,isansi);
                else {
                    if (*isansi) continue;
          sprintf(s,"%-5u %-8s -- %7lu bytes -- %02u/%02u/%u\r\n",x+1,section[x],f.ff_fsize,fdf.fd.month,fdf.fd.day,fdf.fd.year+80);
                }
                pauser=1;
                if (printm(s)) break;
                if(!list_zoo(x,1,(keyword==NULL),keyword)) break;
            }
            if (p) break;
        }
        pauser=0;
        if (numlines) if (lines>numlines-12) hitreturn();
}



void pascal quick_list (void) {

    register word x;
    char s[81];

    printg("\x1b[0;1;37m");
    pauser=1;
  printm("\r\n  Available Documents:\r\n");
    pauser=2;
    for (x=0;x<numfiles;x++) {
            if (graphics) printfm("%s%-5u %s%-12s     ","\x1b[0;1;31m",x+1,"\x1b[33m",document[x]);
            else printfm("%-5u %-12s     ",x+1,document[x]);
        if (!((x+1)%3)) {
            pauser=1;
      if (printm("\r\n")) break;
            pauser=2;
        }
        if (inkey()==' ') break;
    }
    if ((x+1)%3) {
        pauser=2;
    printm("\r\n");
    }
    pauser=0;
    if (numlines) if (lines>numlines-12) hitreturn();
}


word pascal security (void) {

    int handle;
    char s[81];
    register word x;
    register word z;

    if ((handle=_open(secfile,O_RDONLY | O_BINARY | O_DENYNONE))==-1) {
    ansi_out("\r\x1b[K\04Cannot open security file.");
        my_sleep(1);
        return 0;
    }
    while (!eof(handle) && numsecs) {
        if (!fgetsx(s,81,handle)) break;
        for (x=0;x<numsecs;x++) {
            if (!strcmp(strtok(s," "),section[x])) {
                if (seclvl<(word)atol(strtok(0," "))) {
                    for(z=x;z<numsecs;z++) {
                        section[x]=NULL;
                        if (section[x+1]) {
                            strcpy(section[x],section[x+1]);
                            section[x]=section[x+1];
                            section[x+1]=0;
                        }
                        numsecs=numsecs-1;
                    }
                }
                break;
            }
         }
    }
    _close(handle);
    return numsecs;
}



char * pascal lstrip (char *a) {

  register int x;

  x=strlen(a);
  while (x && *a==' ') memmove (a,(a+1),x--);
  return (a);
}




int cdecl break_handler (void) {

   status();
   return 1;
}


void pascal chat (void) {

char a;

 printg("\x1b[0;1;33m");
 printm("\r\n\r\nChat mode engaged\r\n\r\n");
 while (chatting) {
   a=inkey();
   if (chatting) {
   if (a==13) printm("\r\n");
     else printfm("%c",a);
   }
 }
 printm("\r\n\r\nChat mode ended\r\n\r\n");
 chatted++;
}


char pascal readtext (char *s) {

    long place;
    long place2;
    struct ffblk filestat;
  static char dostring[896];
  char eeof=0;
    word page;
    char a;
    long *pos;
    int  handle;
    register int x;
    char prev=0;
    char *p;
    char *here;
    char temp='N';
    char lastpage=0;
    char searchstring[41];
    char holdstring[41];
    char teststring[81];
    char findend=0;
    char printanyway=0;
    char linelen;
    char ismenu=0;


    *searchstring=0;
    *holdstring=0;

  if (findfirst(s,&filestat,0)) return 1;
  if (!filestat.ff_fsize) return 1;
  if ((handle=_open(s,O_RDONLY | O_BINARY | O_DENYNONE)) == -1) {
    if (errno == EACCES) {
      printm("\r\nSorry, file is in use, access denied\r\n");
            return 1;
        }
  }
  p = strchr(s,':');      /* Strip path off filename for display */
  here = strrchr(s,'\\');
  if(!p && !here) here = s;
  else if (!here) here = &p[1];
  else if (p) here= (p < here) ? &here[1] : &p[1];
  else here++;
  cls();
  printg("\x1b[0;1;33m");
  page = 0;
  place2 = tell(handle);
  if (stristr(s,"LIBSUBOP.MNU") || stristr(s,"LIBRARY.MNU")) ismenu=1;
  if ((grapharea && (!stristr(s,"LIBSUBOP.HLP") && !stristr(s,"LIBRARY.HLP"))) || ismenu) {
      if (!ismenu) {
      cls();
      }
    else printm("\r\n");
    pauser = 0;
    while (!eof(handle)) {
      page = 512;
      place2 = filestat.ff_fsize - tell(handle);
      if(place2 < (long)page) page = (word)place2;
      page = read(handle,dostring,page);
      if(!page || page == 65535U) break;
      dostring[page] = 0;
      if(baud) {
        p = dostring;
        while(*p) {
          while(!fossil(TRANSMIT,*p)) carrchk();
          p++;
        }
      }
      ansi_out(dostring);
      if(!ismenu) {
        a = toupper(inkey());
        if (a == 'S' || a == ' ') break;
        if (a == 'P') my_sleep(5);
      }
    }
    _close(handle);
      if(!ismenu) {
      if (numlines) if (lines > numlines - 12) hitreturn();
      }
      return 0;
  }
  if (!baud && *reader) {
    _close(handle);
    sprintf(dostring,"%s %s",reader,s);
    system(dostring);
    set_screensize(1);
    validate_cursor();
    status();
    return 0;
  }
  pos = (long *)malloc((word)(sizeof(long)*MAXPTRS));
  if(!pos) {
    _close(handle);
    printm("\r\nOut of memory\r\n");
    exit(4);
  }
  printfm(" -=-=Reading: %s=-=-  Page #%u\r\n",here,page+1);
  printg("\x1b[0;1;32m");
  if(skip_blanks(handle)) goto Abort;
  place2 = pos[0] = tell(handle);
  pauser = 1;
  lines = 1;
  while (!eof(handle)) {
    if ((*searchstring && !printanyway) || findend) goto Searcher;
Domore:
  if (!fgetsx(dostring,maxx + 2,handle)) {
    eeof++;
        goto EEOF;
    }
  dostring[maxx + 2] = 0;
  stripcr(dostring);
  place2 = tell(handle);
  p = dostring;
  while ((p = strchr(p,'\xc')) != NULL)
   memmove(p,&p[1],strlen(&p[1]) + 1);
  p = dostring;
  while ((p = strchr(p,'\x1b')) != NULL)
   memmove(p,&p[1],strlen(&p[1]) + 1);
  p = dostring;
  while ((p = strchr(p,'\t')) != NULL) {
    memmove(&p[tabspaces - 1],p,strlen(p) + 1);
    for(x = 0;x < tabspaces;x++) p[x] = ' ';
  }
  dostring[maxx - 1] = 0;

  if (!*dostring) {
        if (prev) {
            prev=0;
      eeof=skip_blanks(handle);
      if (eeof) goto EEOF;
            else goto Domore;
        }
        else prev++;
    }
    else prev=0;
  strcat(dostring,"\r\n");
  fast = 1;
    if (*searchstring) {
        strcpy(teststring,dostring);
      if (stristr(teststring,searchstring)) {
        pauser=2;
        printg("\x1b[0;1;37m");
        pauser=1;
        fast=2;
        if (printm(dostring)) break;
        pauser=2;
        printg("\x1b[0;1;32m");
        pauser=1;
      }
      else if (printm(dostring)) break;
    }
    else if (printm(dostring)) break;
    if (strlen(dostring) - 2 > width) lines++;
    a=toupper(inkey());
    if (a=='S' || a==' ') break;
    if (a=='P' || a=='-') if (page) goto SkipThis;
    if (a=='M') goto Direct;
Searcher:
    if (lastpage) goto EEOF;
    if ((a=='N') || (*searchstring) || (findend)) {
      if (findend) {
        if (++page>MAXPTRS) page=1;
        pos[page]=tell(handle);
      }
      place2=place=tell(handle);
Domore1:
      while (!eof(handle)) {
Domore2:
        if (!fgetsx(dostring,maxx + 2,handle)) {
          eeof++;
          break;
        }
        dostring[maxx + 2] = 0;
        stripcr(dostring);
        place2 = tell(handle);
        p = dostring;
        while ((p = strchr(p,'\xc')) != NULL)
         memmove(p,&p[1],strlen(&p[1]) + 1);
        p = dostring;
        while ((p = strchr(p,'\x1b')) != NULL)
         memmove(p,&p[1],strlen(&p[1]) + 1);
        p = dostring;
        while ((p = strchr(p,'\t')) != NULL) {
            memmove(&p[tabspaces - 1],p,strlen(p) + 1);
            for(x = 0;x < tabspaces;x++) p[x] = ' ';
        }
        dostring[maxx - 1] = 0;

        if (!*dostring) {
          if (prev) {
            prev = 0;
            eeof = skip_blanks(handle);
            if (eeof) break;
            else goto Domore2;
          }
          else prev++;
        }
        else prev = 0;
        if (*searchstring) {
          if (stristr(dostring,searchstring)) {
            printanyway++;
            break;
          }
        }
        lines++;
        if (strlen(dostring) >= width) lines++;
        strcat(dostring,"\r\n");
        if (numlines) if ((lines >= numlines - 2) || (eof(handle)) || (eeof)) break;
      }
      fossil(PURGEIN,0);
      eeof = skip_blanks(handle);
      if (eof(handle) || eeof || printanyway) {
        if (*searchstring && !printanyway) {
          pauser=0;
          printm("\r\nNot found...\r\n");
          goto EEOF;
        }
        lseek(handle,place,SEEK_SET);
        cls();
        printg("\x1b[0;1;33m");
        printfm(" -=-=Reading: %s=-=-  Page #%u\r\n",here,page+1);
        printg("\x1b[0;1;32m");
        findend=prev=eeof=0;
        lastpage=lines=pauser=1;
        goto Domore;
      }
      if ((*searchstring || findend) && !eeof) {
      if (++page>MAXPTRS) page=1;
      pos[page]=place=place2=tell(handle);
      lines=1;
      goto Domore1;
    }
    }
EEOF:
  if (numlines) if ((lines>=numlines-2) || (eof(handle)) || (eeof)) {
Direct:
        linelen=0;
        prev=0;
        pauser=0;
    eeof=skip_blanks(handle);
    if (eof(handle) || eeof) {
            printg("\x1b[0;1;31m");
            printm(" (END)");
            linelen+=6;
            printg("\x1b[0;1;33m");
            temp='S';
        }
        else {
            if (a=='M' || a=='N') goto SkipThis;
            temp='N';
            printg("\x1b[0;1;33m");
            printm(" [F]ind [E]nd [N]ext [M]ore");
            linelen+=27;
        }
        if (page) {
            printm(" [H]ome [P]rior");
            linelen+=15;
        }
        linelen+=sprintf(dostring," [O]ver [S]top: [%c] ",temp);
        printm(dostring);
        fossil(FLUSHOUT,0);
    pos[page+1]=tell(handle);
Getitagain:
        fossil(PURGEIN,0);
        a=*genin(1,0,1,1,ALLL);
SkipThis:
        findend=0;
        lastpage=0;
        printanyway=0;
        *searchstring=0;
        switch (a) {
            case 'S':   goto Abort;
            case 'H':   if (!page) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        page=0;
            lseek(handle,0,SEEK_SET);
                        break;
      case 'E':   if (eof(handle) || eeof) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        findend++;
                        break;
      case 'F':   if (eof(handle) || eeof) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        printg("\x1b[0;1;35m");
            printfm("\r\n Search string: [%s]\r\n  -> ",holdstring);
                        strcpy(searchstring,genin(40,0,1,0,ALLL));
                        if (!*searchstring) {
                            if (*holdstring) {
                                strcpy(searchstring,holdstring);
                                if (++page>MAXPTRS) page=1;
                pos[page]=tell(handle);
                            }
                        }
                        else strcpy(holdstring,searchstring);
            lseek(handle,pos[page],SEEK_SET);
            eeof=skip_blanks(handle);
                        break;
      case  0:    if (eof(handle) || eeof) goto Abort;
      case 'N':   if (eof(handle) || eeof) {
                            printm(BACKSPACE);
                            printm("\x7");
                            goto Getitagain;
                        }
                        a=0;
                        if (++page>MAXPTRS) page=1;
            pos[page]=tell(handle);
                        break;
      case 'O':   lseek(handle,pos[page],SEEK_SET);
            eeof=skip_blanks(handle);
                        break;
            case 'P':
            case '-':   if (page) {
              lseek(handle,pos[--page],SEEK_SET);
              eeof=skip_blanks(handle);
                            break;
                        }
                        printm(BACKSPACE);
                        printm("\x7");
                        goto Getitagain;
      case 'M':   if (eof(handle) || eeof) {
                            printm("\x7");
                            printm(BACKSPACE);
                            goto Getitagain;
                        }
                        for (x=0;x<linelen;x++) printm(BACKSPACE);
                        printg("\x1b[0;1;32m");
                        pauser=1;
                        if (numlines) lines=numlines-3;
                        goto Domore;
            default:    printm(BACKSPACE);
                        goto Getitagain;
        }
    place2=tell(handle);
    eeof=0;
        cls();
        printg("\x1b[0;1;33m");
        if (findend || *searchstring) strcpy(teststring,"Scanning");
        else strcpy(teststring,"Reading");
    printfm(" -=-=%s: %s=-=-  Page #%u\r\n",teststring,here,page+1);
        printg("\x1b[0;1;32m");
        pauser=1;
        lines=1;
      }
  }
Abort:
  if(pos) free(pos);
  pauser=0;
  _close(handle);
  return 0;

}



char pascal skip_blanks (int handle) {

  ulong pos;
  char temp[81];
  char eeof=0;

  do {
  pos=tell(handle);
  if (!fgetsx(temp,81,handle)) eeof++;
  } while ((!eeof) && (!eof(handle)) && (!strcmp(temp,"\r\n")));
  if (!eeof && !eof(handle)) lseek(handle,pos,SEEK_SET);
  return eeof;

}



char pascal printg (text)

    char *text;

{

   if (graphics) return (printm(text));
}




char pascal inkey (void)  /* MIMICS BASIC'S INKEY$ FUNCTION */ {

char arg=0;

   rg.h.ah=11;
   int86(33,&rg,&rg);
   if (rg.h.al!=0) {
        rg.h.ah=8;
        int86(33,&rg,&rg);
        if (rg.h.al!=0)return((char)(rg.h.al));
        rg.h.ah=8;
        int86(33,&rg,&rg);
        arg=specialkey(rg.h.al);
        if (arg) return (arg);
   }
   if (baud) {
      arg=carrchk();
      if (!(arg & 1)) return (0);
      return (fossil(RECVWAIT,arg));
   }
   (*pause_mtask)();
   return (0);
}



char pascal specialkey (char a) {

char tempause;
char middle[82];
int  drive;
char dir[MAXDIR];

tempause=pauser;
pauser=0;

  switch (a) {
    case 45: exit (0);      /* QUIT DOOR */
    case 46: if (!chatting) {  /* CHAT */
                chatting++;
                chat();
             }
             else chatting=0;
             break;
    case 35:                /* HANG UP */
       fossil(DTR,DOWN);
       exit(1);
    case 36:                /* SysOp SHELL */
    printm("\r\nThe SysOp has jumped to DOS...please wait...\r\n");
       fossil(FLUSHOUT,0);
       drive=getdisk();
       getcurdir(++drive,dir);
       fossil(DEINIT,0);
       ansi_out("\x1b[0m\x1b[2JEXIT to return to Library\r\n");
           system("");
       set_screensize(1);
       validate_cursor();
       fossil(INIT,0);
       setdisk (--drive);
       strcpy(middle,"\\");
       strcat(middle,dir);
       chdir(middle);
       jumped=1;
       ansi_out("\x1b[0m\x1b[2J");
           status();
    printm("\r\nThe SysOp has returned...please continue...\r\n");
      break;
    case 72:                /* MORE TIME */
      timelimit+=60;
    status();
      break;
    case 80:                /* LESS TIME */
      if (timelimit<60L) timelimit=0L;
      else timelimit-=60L;
    status();
      break;
    case 79:                /* STATUS LINE */
    sprintf(middle,"\r\x1b[K%lu bytes free\r\n",coreleft());
    ansi_out(middle);
      break;
    case 73: pauser=tempause;
             return 'P';
    case 81: pauser=tempause;
             return 'N';
    case 71: pauser=tempause;
             return 'H';
  }
  startt=getxbbstime();
  pauser=tempause;
  return 0;
}



void pascal cls (void)  /* MIMICS BASIC'S CLS FUNCTION LOCAL & REMOTE */ {

    lines=0;

  printm("\x0c");
    if (graphics) {
        printm("\x1b[0m\x1b[2J");
  }
  else {
    ansi_out("\x1b[0m\x1b[2J");
  }

  lines=0;

}



char pascal fossil (char function,char arg) {
                        /*  HANDLES MOST USEFUL FOSSIL CALLS */

  if(!baud) return 0;
  if (function == FLUSHOUT) {
     do {
       carrchk();
       rg.h.ah=3;
       rg.x.dx=commport;
       int86(20,&rg,&rg);
     } while (!(rg.h.ah & 64));
     return(0);
  }

  if (function == WATCHDOG) {
    if(nowatchdog) return 0;
    rg.h.al = arg;
  if(arg) printm("\r\nWatchdog on.\r\n");
  else printm("\r\nWatchdog off.\r\n");
  }
  if (function == DTR) rg.h.al = arg;
  if (function == TRANSWAIT) rg.h.al = arg;
  if (function == TRANSMIT) rg.h.al = arg;
  if (function == ONOFF) rg.h.al = arg;

  rg.x.dx=commport;
  rg.h.ah=function;
  int86(20,&rg,&rg);

  if (function == INIT) {
     if (rg.x.ax != INITOK) {
       ansi_out("\r\x1b[KFossil not responding...RTFM.");
       exit (3);
     }
     return (0);
  }

  if (function == GETSTAT) {
      arg = rg.h.ah;
      if (rg.h.al & 128) {
        arg |= 128;
        return (arg);
      }
      arg &= 127;
      return (arg);
  }

  if (function == RECVWAIT) return (rg.h.al);
  if (function == TRANSMIT) return (rg.x.ax);

  return (0);
}


char pascal printm (char *text)   /*  PRINTS TO MODEM AND SCREEN */ {

  int x;
  char mmore;
  char *p;
  char *pp;

  getxbbstime();

  if (!text || !*text) return (0);

  if (strchr(text,'\xc') || strstr(text,"\x1b[2J")) lines = 0;

  if (baud) {
    p = text;
    while(*p) {
      while (!fossil(TRANSMIT,*p)) carrchk();
      p++;
    }
  }

  p = text;
  while ((p = strchr(p,'\07')) != NULL) memmove(p,&p[1],strlen(&p[1])+1);
  ansi_out(text);
  if (baud && baud<4800 && text[1]) fossil(FLUSHOUT,0);

  if (!pauser || !numlines) {
   lines=0;
   return (0);
  }
  if (pauser == 2) return(0);

  if (numlines) if (++lines>=(numlines-1)) {
    lines=0;
    pauser=0;
    printm ("More? (Y/n) ");
    fossil(FLUSHOUT,0);
    fossil(PURGEIN,0);
    mmore = *genin(1,0,1,1,YESNOM);
    for (x=0;x<12;x++) printm(BACKSPACE);
    if (mmore == 'N') {
       printm ("\r\n");
       return (1);
    }
    pauser=1;
  }
  return (0);
}



void cdecl deinitialize (void)     /*  DEINITIALIZES FOSSIL ON EXIT */ {

 register word x;

 if (numsecs) for (x=0;x<numsecs;x++) if (section[x]) free (section[x]);
 free_docs();
 if (baud) fossil(FLUSHOUT,0);
 fossil (DEINIT,0);
 fcloseall();

 if(tmpin)remove(tmpin);
 if(tmpout)remove(tmpout);
 if(lastextracted)remove(lastextracted);

 if (home_dir[1]==':') {
  setdisk(home_dir[0] - 'A');
    chdir(home_dir);
 }

 ansi_out("\r\n\04\x1b[0;2;37mLibrary down...\r\n");
}


char * pascal genin (char length,char password,char caps,char hot,char type) {
                                         /* GENERIC INPUT ROUTINE */

 static char input[257];
 int x=0;
 char one=0;
 char randchr[2];

 pauser=0;
 length--;

AfterChat:

 strset(input,0);
 startt=getxbbstime();

 while ((getxbbstime()-startt)<241 || jumped) {

  one=inkey();
  if (one == '\r') break;

Nogo:

  if (one == 8) {
      if (x>0) {
         printm(BACKSPACE);
         input [--x]=0;
         if ((type==PHONE) && ((x==2) || (x==5))) printm(BACKSPACE);
         if ((type==DATE) && ((x==1) || (x==3))) printm(BACKSPACE);
      }
      continue;
  }
  if ((caps) || (type==YESNO) || (type==YESNOM) || (type==FLE) || (type==FLEW) || (type==FLEPW) || (type==FLEP) || (type==YESNOQ)) one=toupper(one);
  if (x <= length) {
      if (type==NAME) {
        if((isalpha(one)==0) && (one!=' ') && (one!='.') && (one!='-') || (x==0 && one==' ')) continue;
        if ((one==' ') && (strchr(input,' ')!=NULL)) continue;
      }
      if (type==NEAT) {
        if((isalnum(one)==0) && (one!=' ') || (x==0 && one==' ')) continue;
      }
      if ((type==NEAT) || (type==NAME)) {
        if(x==0) {
            one=toupper(one);
        }
        else one=tolower(one);
      }
      if((type==NEAT) || (type==NAME)) {
        if((x>0) && ((input[x-1]==' ') || (input[x-1]=='.') || (input[x-1]=='-'))) one=toupper(one);
      }
      if ((type==SUBJECT) && (x==0)) one=toupper(one);
      if ((type==SUBJECT) && (isprint(one)==0)) continue;
      if ((type==ALLL) && (isprint(one)==0)) continue;
      if ((type==ALLL) && (one==127)) one=8;
      if ((type==ALPHA) && (isalpha(one)==0) && (one!=' ')) continue;
      if (((type==NUM) || (type==PHONE) || (type==DATE)) && (isdigit(one)==0)) continue;
      if ((type==ALPHANUM) && (isalnum(one)==0) && (one!=' ')) continue;
      if (type==YESNOQ && !strchr("YNQ",one)) continue;
      if (((type==YESNO) || (type==YESNOM)) && (one!='Y' && one!='N')) continue;
      if (type==FLE) {
         if ((isalnum(one)==0) && (!strchr("._-+=!@#$%^&<>/",one))) continue;
      }
      if (type==FLEP) {
         if ((isalnum(one)==0) && (!strchr("._-+=!@#$%^&<>/\\:",one))) continue;
      }
      if (type==FLEW) {
          if ((isalnum(one)==0) && (!strchr("._-+=!@#$%^&<>/?*",one))) continue;
      }
      if (type==FLEPW) {
        if ((isalnum(one)==0) && (!strchr("._-+=!@#$%^&<>/?*\\:",one))) continue;
      }
      if (type==FBATCHW) {
         if ((isalnum(one)==0) && (!strchr(" ._-+=!@#$%^&<>?*{}[]",one))) continue;
      }
      if ((type==FLE) || (type==FLEP) || (type==FLEW) || (type==FLEPW)) {
         if ((one=='.') && (strchr(input,'.')!=NULL)) continue;
      }
   }
   if (jumped>0) {
     jumped=0;
     goto AfterChat;
   }

   if (one && x<=length) {
      input[x]=one;
      input[++x]=0;
      if (type==YESNOM) {
          return(input);
      }
      if (password==0) printm(&input[x-1]);
      if (password!=0) {
        randchr[0]=random(10)+33;
        randchr[1]=0;
        printm(randchr);
      }
      if ((type==PHONE) && ((x==3) || (x==6))) printm("-");
      if ((type==DATE) && ((x==2) || (x==4))) printm("/");
AfterCtrl:
      if (hot && x >= length) {
        return (input);
      }
      startt=getxbbstime();
   }

  }
  if (chatted) {
    chatted=0;
    goto AfterChat;
  }
  if ((getxbbstime()-startt)>240) {
      ansi_out("\r\x1b[K\04User time-out...");
      exit (2);
  }
  return (input);
}


char pascal carrchk (void)  /* Checks for carrier */ {

     if(!baud) return 0;
     rg.x.dx=commport;
     rg.h.ah=GETSTAT;
     int86(20,&rg,&rg);
     if (!(rg.h.al & 128)) {
       rg.x.dx=commport;
       rg.h.ah=GETSTAT;
       int86(20,&rg,&rg);
       if (!(rg.h.al & 128)) {
         fossil(DTR,DOWN);
         ansi_out("\r\x1b[K\04Lost carrier...");
         exit (1);
       }
     }
     return (rg.h.ah);
}


void pascal hitreturn (void) {

  register word x;

   startt=getxbbstime();
   lines=0;
   printm("\r\n[Enter] to continue...");
   while ((getxbbstime()-startt)<241) {
     (*pause_mtask)();
     if (inkey()==13) goto hedid;
   }
   ansi_out("\r\x1b[K\04User time-out...");
   exit (2);
hedid:
   for(x=0;x<22;x++) printm(BACKSPACE);
   lines=0;
}


long pascal getxbbstime (void) {

 char tempause;
 static long xbbs_time;
 static int warned;
 static long last_time;

 tempause=pauser;
 pauser=2;

 xbbs_time=time(NULL);

  if((xbbs_time-last_time)>60L) {
    last_time=xbbs_time;
    status();
  }

 if (timelimit<(xbbs_time+120L) && !warned) {
    warned++;
  printfm("\r\nWARNING: %u minutes remaining.",(timelimit-xbbs_time)/60L);
 }
 if (timelimit > (xbbs_time+121L) && warned) warned=0;
 if (timelimit < xbbs_time) {
    timelimit=xbbs_time+240L;
    printm ("\r\nSorry, time to logoff...\r\n");
    fossil (FLUSHOUT,0);
    exit(0);
 }

 pauser=tempause;
 return(xbbs_time);
}



void pascal printinfo (void) {

  aprintf("\r\n\04Copyright (c) 1988/89/90/91/92 by M. Kimes--All Rights Reserved"
          "\r\n\04Compiled: %s  %s\r\n",__DATE__,__TIME__);

}



char * pascal fidodate (void) {

 char months[12][4]={
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
 };
 static char fdate[20];
 struct date dos_date;
 struct time dos_time;

/* 26 Jul 89  06:23:47 */

 getdate(&dos_date);
 gettime(&dos_time);

 sprintf(fdate,"%02hu %s %02d  %02hu:%02hu:%02hu",dos_date.da_day,months[dos_date.da_mon-1],dos_date.da_year%100,dos_time.ti_hour,dos_time.ti_min,dos_time.ti_sec);
 return(fdate);

}



char * pascal rstrip (char *a) {

  register int x;

  x=strlen(a);
  while (x && a && a[x-1]==' ') a[--x]=0;
  return a;
}



int cdecl printfm (char *string,...) {

 static char buffer[318];

 va_list ap;
 va_start(ap,string);
 vsprintf(buffer,string,ap);
 va_end(ap);
 return(printm(buffer));
}



int cdecl aprintf (char *string,...) {

 static char buffer[318];

 va_list ap;
 va_start(ap,string);
 vsprintf(buffer,string,ap);
 va_end(ap);
 return(ansi_out(buffer));
}



void pascal free_docs (void) {

    register word x;

    if (numfiles) {
        for (x=(numfiles-1);x<numfiles;x--) {
            if (document[x]) {
                free(document[x]);
            }
            document[x]=NULL;
        }
        numfiles=0;
    }
}


char * pascal stristr (char *t, char *s) {

   char *t1;
   char *s1;

   while(*t) {
      t1=t;
      s1=s;
      while(*s1) {
         if (toupper(*s1)!=toupper(*t)) break;
         else {
            s1++;
            t++;
         }
      }
      if (!*s1) return t1;
      t=t1+1;
   }
   return NULL;
}



void pascal status (void) {

  char s[88],*b;
  int  x = 0,xx,yy;


  curr_cursor(&xx,&yy);
  sprintf(s,"%-26.26s %c %-5u %c %-31.31s %c %03lu "," Library v1.09 by M. Kimes",254,baud,254,username,254,(timelimit - getxbbstime())/60L);
  b = s;
  while(*b) {
    put_char(*b,7 * 16,x,realmaxy - 1);
    b++;
    x++;
  }
  pos_hardcursor(xx,yy);
}


void pascal curr_cursor (int *x, int *y) {

  _AX = 0x0300;
  _BX = 0;
  geninterrupt(0x10);
  *x = _DL;
  *y = _DH;
}


char * pascal stripcr (char *a) {

  register int x;

  x = strlen(a);
  while (x && (a[x - 1] == '\n' || a[x-1] == '\r')) a[--x] = 0;
  return a;
}


char * pascal fgetsx (char *str,int num,int handle) {

    static char *p;
    static long pos;
    static int x;

    if (eof(handle)) {
        *str=0;
        return NULL;
    }
    pos=tell(handle);
    x=_read(handle,str,num-1);
    if (x<1) {
        *str=0;
        return NULL;
    }
    str[x]=0;
    p=str;
    while(*p && *p!='\r' && *p!='\n') p++;
    if(!*p) return str;
    if(*p=='\r') {
        *p='\n';
        if (p[1]=='\n') {
            p++;
            *p=0;
        }
    }
    p++;
    *p=0;
    lseek(handle,pos+((long)((unsigned int)p-(unsigned int)str)),SEEK_SET);
    return str;
}

